require 'sick'
	
pos = 'up'

gamestate = 'title'

lgni = love.graphics.newImage
lkid = love.keyboard.isDown
lgd = love.graphics.draw
lgp = love.graphics.print

function love.load( )
	
	menu = {
		title = lgni('pics/menus/title.png'),
		game_over = lgni('pics/menus/game_over.png'),
		credits = lgni('pics/menus/credits.png'),
		controls = lgni('pics/menus/Controls.png'),
		howto = lgni('pics/menus/howto.png'),
	}
	player = {
		w = 25,
		h = 50,
		pic = lgni('pics/player_'..pos..'.png'),
		x = 200,
		y = 100,
		score = 0,
		speed = 210,
		lives = 4,
		timer = 0,
	}
	food = {
		x = 69,
		y = 69,
		xx = 500,
		yy = 400,
		w = 20,
		h = 20,
	}
	laser = {
		pic = lgni('pics/laser_across.png'),
		w = 219,
		h = 19,
		x = 0,
		y = 40,
		xx = 100,
		yy = 200,
		xxx = 200,
		yyy = 350,
		xxxx = 400,
		yyyy = 500,
		speed = 300,
	}
end
function love.draw( )
	if gamestate == 'game' then

		love.graphics.rectangle( 'fill', food.x, food.y, food.w, food.h)
		-- love.graphics.rectangle( 'fill', food.xx, food.yy, food.w, food.h)
		-- love.graphics.rectangle('fill', laser.x, laser.y, laser.w, laser.h)
		lgd(laser.pic, laser.x, laser.y)
		lgd(laser.pic, laser.xx, laser.yy)
		lgd(laser.pic, laser.xxx, laser.yyy)
		lgd(laser.pic, laser.xxxx, laser.yyyy)

		lgp('Score: '..player.score..'', 10, 10)
		lgp('Lives: '..player.lives..'', 640, 10)

		--lgd(player.pic, player.x, player.y)
		--love.graphics.circle('fill', player.x, player.y)
		--love.graphics.circle( "fill", 300, 300, 10, 50)

		love.graphics.circle('fill', player.x, player.y,player.w)

	elseif gamestate == 'game_over' then
		lgd(menu.game_over,0,0)
		lgp('Score: '..player.score..'', 319, 81)


	elseif gamestate == 'title' then
		lgd(menu.title,0,0)

	elseif gamestate == 'controls' then
		lgd(menu.controls,0,0)

	elseif gamestate == 'credits' then
		lgd(menu.credits,0,0)

	elseif gamestate == 'howto' then
		lgd(menu.howto,0,0)
	end
end
function love.update( dt )
	if gamestate == 'game' then

		player.timer = player.timer + dt

		if player.timer > 20 and player.timer < 22 then
			-- player.score = player.score + 19000000
			laser.speed = laser.speed + 2
		elseif player.timer > 30 and player.timer < 32 then
			-- player.score = player.score + 19000000
			laser.speed = laser.speed + 2

		end
		laser.x = laser.x + laser.speed * dt
		laser.xx = laser.xx - laser.speed * dt
		laser.xxx = laser.xxx + laser.speed * dt
		laser.xxxx = laser.xxxx - laser.speed * dt

		if laser.x + laser.w > 700 or laser.x + laser.w == 700 then
			laser.x = 0
		elseif laser.xxx + laser.w > 700 or laser.xxx + laser.w == 700 then
			laser.xxx = 0
		elseif laser.xx < 0 or laser.xx == 0 then
			laser.xx = 700
		elseif laser.xxxx < 0 or laser.xxxx == 0 then
			laser.xxxx = 700
		end

		if player.x + player.w > food.x and player.x < food.x + food.w and player.y + player.w > food.y and player.y < food.y + food.h then
			math.randomseed(os.time())
			food.x = math.random(675)
			math.randomseed(os.time())
			food.y = math.random(630)			
			player.score = player.score + 3
		
		-- elseif player.x + player.w > food.xx and player.x < food.xx + food.w and player.y + player.w > food.yy and player.y < food.yy + food.h then
		--	 math.randomseed(os.time())
		--	 food.xx = math.random(675)
		--	 food.yy = math.random(630)
		--	 player.score = player.score + 2

		elseif player.x + player.w > laser.x and player.x < laser.x + laser.w and player.y + player.w > laser.y and player.y < laser.y + laser.h then
			player.x = 200
			player.y = 100
			player.lives = player.lives - 1

		elseif player.x + player.w > laser.xx and player.x < laser.xx + laser.w and player.y + player.w > laser.yy and player.y < laser.yy + laser.h then
			player.x = 200
			player.y = 100
			player.lives = player.lives - 1

		elseif player.x + player.w > laser.xxx and player.x < laser.xxx + laser.w and player.y + player.w > laser.yyy and player.y < laser.yyy + laser.h then
			player.x = 200
			player.y = 100
			player.lives = player.lives - 1

		elseif player.x + player.w > laser.xxxx and player.x < laser.xxxx + laser.w and player.y + player.w > laser.yyyy and player.y < laser.yyyy + laser.h then
			player.x = 200
			player.y = 100
			player.lives = player.lives - 1

		end	

		if lkid('up') or lkid('w') then
			player.y = player.y - player.speed * dt
			pos = 'up'		
			--pic = lgni('pics/player_up.png')
		elseif lkid('down') or lkid('s') then
			player.y = player.y + player.speed * dt
			pos = 'down'		
			--pic = lgni('pics/player_down.png')
		elseif lkid('left') or lkid('a') then
			player.x = player.x - player.speed * dt
			pos = 'left'		
			--pic = lgni('pics/player_left.png')
		elseif lkid('right') or lkid('d') then
			player.x = player.x + player.speed * dt
			pos = 'right'		
			--pic = lgni('pics/player_right.png')
		end
		if player.lives == 0 or player.lives < 0 then
			gamestate = 'game_over'
		end

	elseif gamestate == 'game_over' then

	elseif gamestate == 'title' then

	elseif gamestate == 'controls' then

	elseif gamestate == 'credits' then

	elseif gamestate == 'howto' then

	end
end
function love.keypressed( key )
	if gamestate == 'game' then

	elseif gamestate == 'game_over' then
		if key == 'backspace' then
			gamestate = 'title'

			player = {
				w = 25,
				h = 50,
				pic = lgni('pics/player_'..pos..'.png'),
				x = 200,
				y = 100,
				score = 0,
				speed = 210,
				lives = 4,
				timer = 0,
			}
			food = {
				x = 69,
				y = 69,
				xx = 500,
				yy = 400,
				w = 20,
				h = 20,
			}
			laser = {
				pic = lgni('pics/laser_across.png'),
				w = 219,
				h = 19,
				x = 0,
				y = 40,
				xx = 100,
				yy = 200,
				xxx = 200,
				yyy = 350,
				xxxx = 400,
				yyyy = 500,
				speed = 300,
			}
		elseif key == 'return' then
			player = {
				w = 25,
				h = 50,
				pic = lgni('pics/player_'..pos..'.png'),
				x = 200,
				y = 100,
				score = 0,
				speed = 210,
				lives = 4,
				timer = 0,
			}
			food = {
				x = 69,
				y = 69,
				xx = 500,
				yy = 400,
				w = 20,
				h = 20,
			}
			laser = {
				pic = lgni('pics/laser_across.png'),
				w = 219,
				h = 19,
				x = 0,
				y = 40,
				xx = 100,
				yy = 200,
				xxx = 200,
				yyy = 350,
				xxxx = 400,
				yyyy = 500,
				speed = 300,
			}
			gamestate = 'game'
		elseif key == 'q' or key == 'escape' then
      		love.event.quit()
		end
	elseif gamestate == 'title' then
		if key == 'backspace' then
			gamestate = 'title'
		elseif key == 'return' then
			gamestate = 'game'
		elseif key == 'c' then
			gamestate = 'controls'
		elseif key == 'k' then
			gamestate = 'credits'
		elseif key == 'h' then
			gamestate = 'howto'
		end
	elseif gamestate == 'controls' then
		if key == 'backspace' then
			gamestate = 'title'
		end
	elseif gamestate == 'credits' then
		if key == 'backspace' then
			gamestate = 'title'
		end
	elseif gamestate == 'howto' then
		if key == 'backspace' then
			gamestate = 'title'
		end
	end
end